## snort 3.9.7.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5)
project (snort CXX C)

set (VERSION_MAJOR 3)
set (VERSION_MINOR 9)
set (VERSION_PATCH 7)
set (VERSION_SUBLEVEL 0)
set (VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_SUBLEVEL}")

if (DEFINED VERSION_BUILD)
    set (BUILD "${VERSION_BUILD}")
endif ()

set (CMAKE_CXX_STANDARD 17)
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_CXX_EXTENSIONS OFF)

set (CMAKE_C_STANDARD 99)
set (CMAKE_C_STANDARD_REQUIRED ON)
set (CMAKE_C_EXTENSIONS ON)

# dump compile_commands.json to make it easier to use clangd with IDEs
set (CMAKE_EXPORT_COMPILE_COMMANDS ON)

set (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
# Pull in definitions of various install directories
include (GNUInstallDirs)
include (${CMAKE_MODULE_PATH}/macros.cmake)
include (${CMAKE_MODULE_PATH}/create_options.cmake)
include (${CMAKE_MODULE_PATH}/include_libraries.cmake)
include (${CMAKE_MODULE_PATH}/platforms.cmake)
include (${CMAKE_MODULE_PATH}/configure_options.cmake)
#include (${CMAKE_MODULE_PATH}/compiler_features.cmake)
include (${CMAKE_MODULE_PATH}/sanity_checks.cmake)

set (INSTALL_SUFFIX "${CMAKE_PROJECT_NAME}")
set (INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_SUFFIX}")
set (LIB_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}/${INSTALL_SUFFIX}")
set (PLUGIN_INSTALL_PATH "${LIB_INSTALL_PATH}/plugins")

configure_file (
    "${PROJECT_SOURCE_DIR}/config.cmake.h.in"
    "${PROJECT_BINARY_DIR}/config.h"
)

add_definitions( -DHAVE_CONFIG_H )

# Set these after all tests are done but *before* any subdirectories are included
#  or other targets declared.
string(APPEND CMAKE_C_FLAGS " ${EXTRA_C_FLAGS}")
string(APPEND CMAKE_CXX_FLAGS " ${EXTRA_CXX_FLAGS}")
string(APPEND CMAKE_EXE_LINKER_FLAGS " ${EXTRA_LINKER_FLAGS}")
string(APPEND CMAKE_MODULE_LINKER_FLAGS " ${EXTRA_LINKER_FLAGS}")

include_directories (${PROJECT_BINARY_DIR})
include_directories (${PROJECT_SOURCE_DIR})

if (ENABLE_UNIT_TESTS)
    include(CTest)
endif (ENABLE_UNIT_TESTS)

if (ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS)
    add_custom_target (check COMMAND ${CMAKE_CTEST_COMMAND})
endif (ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS)

add_subdirectory (src)
add_subdirectory (tools)
add_subdirectory (lua)
add_subdirectory (daqs)

if ( MAKE_DOC )
    add_subdirectory (doc)
endif ( MAKE_DOC )

# Miscellaneous stuff.  Does NOT directly affect Snort's build environment.
include (${CMAKE_MODULE_PATH}/packaging_data.cmake)
include (${CMAKE_MODULE_PATH}/create_pkg_config.cmake)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

string(TOUPPER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_UPPER)

message("
-------------------------------------------------------")
if (DEFINED BUILD)
    message("${CMAKE_PROJECT_NAME} version ${VERSION} build ${BUILD}")
else()
    message("${CMAKE_PROJECT_NAME} version ${VERSION}")
endif()
message("
Install options:
    prefix:     ${CMAKE_INSTALL_PREFIX}
    includes:   ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${INSTALL_SUFFIX}
    plugins:    ${CMAKE_INSTALL_FULL_LIBDIR}/${INSTALL_SUFFIX}

Compiler options:
    CC:             ${CMAKE_C_COMPILER}
    CXX:            ${CMAKE_CXX_COMPILER}
    CFLAGS:         ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_UPPER}}
    CXXFLAGS:       ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE_UPPER}}
    EXE_LDFLAGS:    ${CMAKE_EXE_LINKER_FLAGS}
    MODULE_LDFLAGS: ${CMAKE_MODULE_LINKER_FLAGS}

Feature options:\
")

if (ENABLE_STATIC_DAQ)
    message("\
    DAQ Modules:    Static (${DAQ_STATIC_MODULES})")
else ()
    message("\
    DAQ Modules:    Dynamic")
endif ()

if (HAVE_ATOMIC)
    message("\
    libatomic:      User-specified")
else ()
    message("\
    libatomic:      System-provided")
endif ()

if (HAVE_HYPERSCAN)
    message("\
    Hyperscan:      ON")
else ()
    message("\
    Hyperscan:      OFF")
endif ()

if (HAVE_ICONV)
    message("\
    ICONV:          ON")
else ()
    message("\
    ICONV:          OFF")
endif ()

if (HAVE_LIBUNWIND)
    message("\
    Libunwind:      ON")
else ()
    message("\
    Libunwind:      OFF")
endif ()

if (HAVE_LZMA)
    message("\
    LZMA:           ON")
else ()
    message("\
    LZMA:           OFF")
endif ()

if (USE_TIRPC)
    message("\
    RPC DB:         TIRPC")
else ()
    message("\
    RPC DB:         Built-in")
endif ()

if (HAVE_SAFEC)
    message("\
    SafeC:          ON")
else ()
    message("\
    SafeC:          OFF")
endif ()

if (HAVE_TCMALLOC)
    message("\
    TCMalloc:       ON")
else ()
    message("\
    TCMalloc:       OFF")
endif ()

if (HAVE_JEMALLOC)
    message("\
    JEMalloc:       ON")
else ()
    message("\
    JEMalloc:       OFF")
endif ()

if (HAVE_UUID)
    message("\
    UUID:           ON")
else ()
    message("\
    UUID:           OFF")
endif ()

if (HAVE_NUMA)
    message("\
    NUMA:           ON")
else ()
    message("\
    NUMA:           OFF")
endif ()

if (HAVE_LIBML)
    message("\
    LibML:          ON")
else ()
    message("\
    LibML:          OFF")
endif ()

message("-------------------------------------------------------\n")

=== doc/reference/CMakeLists.txt ===

set (
    HELP_SOURCES
    commands.txt
    config.txt
    counts.txt
    modules.txt
    plugins.txt
    options.txt
    signals.txt
    help.txt
)

set (
    LIST_SOURCES
    gids.txt
)

set (
    MODULE_SOURCES
    basic.txt
    codec.txt
    connector.txt
    data.txt
    inspector.txt
    ips_action.txt
    ips_option.txt
    logger.txt
)

set (
    UNBUILT_SOURCES
    appendix.txt
    building.txt
    builtin_stubs.txt
    enviro.txt
    snort_reference.txt
)

set (
    DEFAULT_MANUALS
    snort_reference.text
)

function ( add_help_command generator_script output_file )
    add_custom_command (
        OUTPUT ${output_file}
        COMMAND ${generator_script} $<TARGET_FILE:snort> ${output_file} $ENV{SNORT_PLUGIN_PATH}
        DEPENDS snort
        COMMENT "Documents: building ${output_file}"
    )
endfunction ( add_help_command )

foreach ( output_file ${HELP_SOURCES} )
    add_help_command (
        "${CMAKE_CURRENT_LIST_DIR}/scripts/generate_help.sh"
        "${output_file}"
    )
    list ( APPEND BUILT_SOURCES "${output_file}" )
endforeach ()

foreach ( output_file ${LIST_SOURCES} )
    add_help_command (
        "${CMAKE_CURRENT_LIST_DIR}/scripts/generate_list.sh"
        "${output_file}"
    )
    list ( APPEND BUILT_SOURCES "${output_file}" )
endforeach ()

foreach ( output_file ${MODULE_SOURCES} )
    add_help_command (
        "${CMAKE_CURRENT_LIST_DIR}/scripts/generate_module.sh"
        "${output_file}"
    )
    list ( APPEND BUILT_SOURCES "${output_file}" )
endforeach ()

add_custom_command (
    OUTPUT version.txt
    COMMAND $<TARGET_FILE:snort> -V 2>&1 | grep -o "Version.*$" > version.txt
    COMMAND sed -i -e "s/Version/:revnumber:/" version.txt
    DEPENDS snort
    COMMENT "Documents: building version.txt"
)
list ( APPEND BUILT_SOURCES version.txt )

add_custom_command (
    OUTPUT builtin.txt
    COMMAND ${CMAKE_CURRENT_LIST_DIR}/scripts/generate_builtin.sh $<TARGET_FILE:snort> ${CMAKE_CURRENT_LIST_DIR}/builtin_stubs.txt builtin.txt $ENV{SNORT_PLUGIN_PATH} 
    DEPENDS snort
    COMMENT "Documents: building builtin.txt"
)
list ( APPEND BUILT_SOURCES builtin.txt )

foreach ( file_name ${BUILT_SOURCES} )
    list (
        APPEND
        BINARY_DIR_BUILT_SOURCES
        "${CMAKE_CURRENT_BINARY_DIR}/${file_name}"
    )
endforeach ( file_name )

foreach ( file_name ${UNBUILT_SOURCES} )
    list (
        APPEND
        LIST_DIR_SOURCES
        "${CMAKE_CURRENT_LIST_DIR}/${file_name}"
    )
endforeach ( file_name )

add_custom_target (
    ref_built_sources
    DEPENDS ${BUILT_SOURCES}
)

if ( MAKE_HTML_DOC )
    set (
        HTML_ASCIIDOC_ARGS
        -b xhtml11 -a toc2 -a icons -a imagesdir=.
    )

    set (
        HTML_A2X_ARGS
        --format=chunked
        --attribute=linkcss --attribute=stylesdir --attribute=disable-javascript
        --xsltproc-opts=\"--stringparam chunk.tocs.and.lots 1\"
        --attribute=quirks! --attribute=imagesdir=.
        --resource=.
    )

    set ( HTML_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/html/" )

    add_custom_command (
        OUTPUT "${HTML_DOC_TMP}/"
        COMMAND mkdir -p ${HTML_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_reference.html
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} .
        COMMAND ${ASCIIDOC_EXE} ${HTML_ASCIIDOC_ARGS} snort_reference.txt
        COMMAND mv snort_reference.html ../
        DEPENDS ref_built_sources "${HTML_DOC_TMP}/"
        WORKING_DIRECTORY ${HTML_DOC_TMP}
        COMMENT "Documents: building snort_reference.html"
    )

    add_custom_target (
        docs-reference-html
        DEPENDS snort_reference.html
    )

    foreach ( file_name ${UNBUILT_SOURCES} )
        list (
        APPEND
        BINARY_DIR_UNBUILT_SOURCES
        "${CMAKE_CURRENT_BINARY_DIR}/${file_name}"
        )
    endforeach ( file_name )

endif ( MAKE_HTML_DOC )

if ( MAKE_TEXT_DOC )
    set (
        TEXT_A2X_ARGS
        --format=text
    )

    set ( TEXT_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/text" )

    add_custom_command (
        OUTPUT "${TEXT_DOC_TMP}/"
        COMMAND mkdir -p ${TEXT_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_reference.text
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} .
        COMMAND ${ASCIIDOC_A2X_EXE} ${TEXT_A2X_ARGS} snort_reference.txt
        COMMAND mv snort_reference.text ../
        DEPENDS ref_built_sources "${TEXT_DOC_TMP}/"
        WORKING_DIRECTORY ${TEXT_DOC_TMP}
        COMMENT "Documents: building snort_reference.text"
    )

    add_custom_target (
        docs-reference-text
        DEPENDS snort_reference.text
    )

endif ( MAKE_TEXT_DOC )

if ( MAKE_PDF_DOC )
    set (
        PDF_A2X_ARGS
        --format=pdf
        --attribute=imagesdir=.
    )

    set ( PDF_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/pdf" )

    add_custom_command (
        OUTPUT "${PDF_DOC_TMP}/"
        COMMAND mkdir -p ${PDF_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_reference.pdf
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} .
        COMMAND ${ASCIIDOC_A2X_EXE} ${PDF_A2X_ARGS} snort_reference.txt
        COMMAND mv snort_reference.pdf ../
        DEPENDS ref_built_sources "${PDF_DOC_TMP}/"
        WORKING_DIRECTORY ${PDF_DOC_TMP}
        COMMENT "Documents: building snort_reference.pdf"
    )

    add_custom_target (
        docs-reference-pdf
        DEPENDS snort_reference.pdf
    )

endif ( MAKE_PDF_DOC )

install (
    FILES
    ${UNBUILT_SOURCES}
    ${DEFAULT_MANUALS}
    DESTINATION
    ${CMAKE_INSTALL_DOCDIR}
)

set (
    EXTRA_CLEAN
    ${EXTRA_CLEAN}
    ${BINARY_DIR_BUILT_SOURCES}
)

if ( NOT CMAKE_CURRENT_LIST_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR )
    list (
        APPEND
        EXTRA_CLEAN
        ${BINARY_DIR_UNBUILT_SOURCES}
    )
endif ()

if ( EXTRA_CLEAN )
    set_property (
        DIRECTORY
        PROPERTY
        ADDITIONAL_MAKE_CLEAN_FILES ${EXTRA_CLEAN}
    )
endif ( EXTRA_CLEAN )

=== doc/user/CMakeLists.txt ===

set (
    UNBUILT_SOURCES
    active.txt
    appid.txt
    binder.txt
    byte_extract.txt
    byte_jump.txt
    byte_math.txt
    byte_options.txt
    byte_test.txt
    concepts.txt
    connectors.txt
    dump_config.txt
    daq.txt
    dcerpc.txt
    errors.txt
    extractor.txt
    features.txt
    file_processing.txt
    ftp.txt
    high_availability.txt
    http_inspect.txt
    http2_inspect.txt
    iec104.txt
    js_norm.txt
    mms.txt
    overview.txt
    params.txt
    perf_monitor.txt
    pop_imap.txt
    port_scan.txt
    sensitive_data.txt
    side_channel.txt
    smtp.txt
    snort2x.png
    snort3x.png
    snort_user.txt
    snorty.png
    telnet.txt
    terms.txt
    trace.txt
    tutorial.txt
    usage.txt
    wizard.txt
)

set (
    DEFAULT_MANUALS
    snort_user.text
)

foreach ( file_name ${UNBUILT_SOURCES} )
    list (
        APPEND
        LIST_DIR_SOURCES
        "${CMAKE_CURRENT_LIST_DIR}/${file_name}"
    )
endforeach ( file_name )

add_custom_command (
    OUTPUT version.txt
    COMMAND $<TARGET_FILE:snort> -V 2>&1 | grep -o "Version.*$" > version.txt
    COMMAND sed -i -e "s/Version/:revnumber:/" version.txt
    DEPENDS snort
    COMMENT "Documents: building version.txt"
)

list ( APPEND BUILT_SOURCES version.txt )

foreach ( file_name ${BUILT_SOURCES} )
    list (
        APPEND
        BINARY_DIR_BUILT_SOURCES
        "${CMAKE_CURRENT_BINARY_DIR}/${file_name}"
    )
endforeach ( file_name )

add_custom_target (
    usr_built_sources
    DEPENDS ${BUILT_SOURCES}
)

if ( MAKE_HTML_DOC )
    set (
        HTML_ASCIIDOC_ARGS
        -b xhtml11 -a toc2 -a icons -a imagesdir=.
    )

    set (
        HTML_A2X_ARGS
        --format=chunked
        --attribute=linkcss --attribute=stylesdir --attribute=disable-javascript
        --xsltproc-opts=\"--stringparam chunk.tocs.and.lots 1\"
        --attribute=quirks! --attribute=imagesdir=.
        --resource=.
    )

    set ( HTML_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/html/" )

    add_custom_command (
        OUTPUT "${HTML_DOC_TMP}/"
        COMMAND mkdir -p ${HTML_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_user.html snort_online.html
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} ./
        COMMAND ${ASCIIDOC_EXE} ${HTML_ASCIIDOC_ARGS} snort_user.txt
        COMMAND ${CMAKE_CURRENT_LIST_DIR}/online_manual.sh
        COMMAND mv snort_user.html snort_online.html ../
        DEPENDS usr_built_sources "${HTML_DOC_TMP}/"
        WORKING_DIRECTORY ${HTML_DOC_TMP}
        COMMENT "Documents: building snort_user.html and snort_online.html"
    )

    set ( TGZ_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/tgz/" )

    add_custom_command (
        OUTPUT "${TGZ_DOC_TMP}/"
        COMMAND mkdir -p ${TGZ_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_user.tgz
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} ./
        COMMAND ${ASCIIDOC_A2X_EXE} ${HTML_A2X_ARGS} snort_user.txt
        COMMAND tar zcf ../snort_user.tgz snort_user.chunked
        DEPENDS usr_built_sources "${TGZ_DOC_TMP}/"
        WORKING_DIRECTORY ${TGZ_DOC_TMP}
        COMMENT "Documents: building snort_user.tgz"
    )

    add_custom_target (
        docs-user-html
        DEPENDS snort_user.html snort_user.tgz
    )

    foreach ( file_name ${UNBUILT_SOURCES} )
        list (
            APPEND
            BINARY_DIR_UNBUILT_SOURCES
            "${CMAKE_CURRENT_BINARY_DIR}/${file_name}"
        )
    endforeach ( file_name )

endif ( MAKE_HTML_DOC )

if ( MAKE_TEXT_DOC )
    set (
        TEXT_A2X_ARGS
        --format=text
    )

    set ( TEXT_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/text" )

    add_custom_command (
        OUTPUT "${TEXT_DOC_TMP}/"
        COMMAND mkdir -p ${TEXT_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_user.text
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} ./
        COMMAND ${ASCIIDOC_A2X_EXE} ${TEXT_A2X_ARGS} snort_user.txt
        COMMAND mv snort_user.text ../
        DEPENDS usr_built_sources "${TEXT_DOC_TMP}/"
        WORKING_DIRECTORY ${TEXT_DOC_TMP}
        COMMENT "Documents: building snort_user.text"
    )

    add_custom_target (
        docs-user-text
        DEPENDS snort_user.text
    )

endif ( MAKE_TEXT_DOC )

if ( MAKE_PDF_DOC )
    set (
        PDF_A2X_ARGS
        --format=pdf
        --attribute=imagesdir=.
    )

    set ( PDF_DOC_TMP "${CMAKE_CURRENT_BINARY_DIR}/pdf" )

    add_custom_command (
        OUTPUT "${PDF_DOC_TMP}/"
        COMMAND mkdir -p ${PDF_DOC_TMP}
    )

    add_custom_command (
        OUTPUT snort_user.pdf
        COMMAND cp ${LIST_DIR_SOURCES} ${BINARY_DIR_BUILT_SOURCES} ./
        COMMAND ${ASCIIDOC_A2X_EXE} ${PDF_A2X_ARGS} snort_user.txt
        COMMAND mv snort_user.pdf ../
        DEPENDS usr_built_sources "${PDF_DOC_TMP}/"
        WORKING_DIRECTORY ${PDF_DOC_TMP}
        COMMENT "Documents: building snort_user.pdf"
    )

    add_custom_target (
        docs-user-pdf
        DEPENDS snort_user.pdf
    )

endif ( MAKE_PDF_DOC )

install (
    FILES
    ${UNBUILT_SOURCES}
    ${DEFAULT_MANUALS}
    DESTINATION
    ${CMAKE_INSTALL_DOCDIR}
)

set (
    EXTRA_CLEAN
    ${BINARY_DIR_BUILT_SOURCES}
)

if ( NOT CMAKE_CURRENT_LIST_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR )
    list (
        APPEND
        EXTRA_CLEAN
        ${BINARY_DIR_UNBUILT_SOURCES}
    )
endif ()

if ( EXTRA_CLEAN )
    set_property (
        DIRECTORY
        PROPERTY
        ADDITIONAL_MAKE_CLEAN_FILES ${EXTRA_CLEAN}
    )
endif ( EXTRA_CLEAN )

=== src/events/CMakeLists.txt ===

set (INCLUDES
    event.h
)

add_library (events OBJECT
    event.cc
    event_queue.cc
    event_queue.h
    sfeventq.cc
    sfeventq.h
    ${INCLUDES}
)

install (FILES ${INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/events"
)

=== src/framework/CMakeLists.txt ===
add_subdirectory(test)

set (FRAMEWORK_INCLUDES
    base_api.h
    codec.h
    connector.h
    counts.h
    cursor.h
    data_bus.h
    decode_data.h
    endianness.h
    inspector.h
    ips_action.h
    ips_option.h
    logger.h
    module.h
    mp_data_bus.h
    mpse.h
    mpse_batch.h
    parameter.h
    pig_pen.h
    pdu_section.h
    policy_selector.h
    plugins.h
    range.h
    so_rule.h
    value.h
    mp_transport.h
)

add_library ( framework OBJECT
    ${FRAMEWORK_INCLUDES}
    act_info.h
    codec.cc
    cursor.cc
    data_bus.cc
    inspector.cc
    ips_info.h
    ips_action.cc
    ips_option.cc
    lua_api.h
    parameter.cc
    pig_pen.cc
    module.cc
    mp_data_bus.cc
    mpse.cc
    mpse_batch.cc
    range.cc
    value.cc
)

install (FILES ${FRAMEWORK_INCLUDES}
    ${CMAKE_CURRENT_BINARY_DIR}/api_options.h
    ${CMAKE_CURRENT_BINARY_DIR}/snort_api.h
    DESTINATION "${INCLUDE_INSTALL_PATH}/framework"
)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/api_options.h
    COMMAND grep API_OPTIONS ${CMAKE_BINARY_DIR}/config.h > ${CMAKE_CURRENT_BINARY_DIR}/api_options.h
    DEPENDS ${CMAKE_BINARY_DIR}/config.h
)

add_custom_target(api_options ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/api_options.h)

list(APPEND inc_local ".")
list(APPEND inc_local "${CMAKE_CURRENT_BINARY_DIR}/..")
list(TRANSFORM inc_local PREPEND "-I")

list(APPEND inc_external ${EXTERNAL_INCLUDES})
list(TRANSFORM inc_external PREPEND "-idirafter")

list(APPEND inc_dirs ${inc_local})
list(APPEND inc_dirs ${inc_external})
list(JOIN inc_dirs " " INC_DIRS)

add_custom_command(
    OUTPUT
        ${CMAKE_CURRENT_BINARY_DIR}/snort_api.h
    COMMAND
        ${CMAKE_CURRENT_SOURCE_DIR}/plug_gen.sh ${CMAKE_CXX_COMPILER} ${CMAKE_CURRENT_SOURCE_DIR} ${INC_DIRS} > ${CMAKE_CURRENT_BINARY_DIR}/snort_api.h
    DEPENDS
        ${CMAKE_CURRENT_SOURCE_DIR}/plug_gen.sh
        ${CMAKE_CURRENT_SOURCE_DIR}/plugins.h
        ${CMAKE_CURRENT_BINARY_DIR}/api_options.h
)

add_custom_target(snort_api ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/snort_api.h)

set_property(
    DIRECTORY
    PROPERTY
    ADDITIONAL_MAKE_CLEAN_FILES api_options.h snort_api.h
)

add_catch_test( parameter_test
    NO_TEST_SOURCE
    SOURCES
        parameter.cc
    LIBS
        ${DNET_LIBRARIES}
)

add_catch_test( range_test
    NO_TEST_SOURCE
    SOURCES
        range.cc
)

=== src/managers/CMakeLists.txt ===

set (LUA_INCLUDES
    # required 'header'
    ${CMAKE_CURRENT_BINARY_DIR}/snort_plugin.lua
)

set (CPP_INCLUDES
    ${CMAKE_CURRENT_BINARY_DIR}/lua_coreinit.h
)

add_subdirectory(test)

add_library( managers OBJECT
    ${LUA_INCLUDES}
    ${CPP_INCLUDES}
    action_manager.h
    action_manager.cc
    codec_manager.cc
    codec_manager.h
    event_manager.cc
    event_manager.h
    inspector_manager.cc
    inspector_manager.h
    ips_manager.cc
    ips_manager.h
    lua_plugin_defs.h
    module_manager.cc
    module_manager.h
    mpse_manager.cc
    mpse_manager.h
    plugin_manager.cc
    plugin_manager.h
    policy_selector_manager.cc
    policy_selector_manager.h
    script_manager.cc
    script_manager.h
    so_manager.cc
    so_manager.h
    connector_manager.cc
    connector_manager.h
    mp_transport_manager.cc
    mp_transport_manager.h
)

add_custom_command (
    OUTPUT plugffi.lua snort_plugin.lua
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ffi_wrap.sh ${CMAKE_CURRENT_SOURCE_DIR}/lua_plugin_defs.h > plugffi.lua
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/plugffi.lua ${CMAKE_CURRENT_BINARY_DIR}/snort_plugin.lua
)

add_custom_command (
    OUTPUT lua_coreinit.h
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../lua_wrap.sh ${CMAKE_CURRENT_SOURCE_DIR} coreinit > lua_coreinit.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/coreinit.lua
)

include_directories (${CMAKE_CURRENT_BINARY_DIR})

install (FILES ${LUA_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/lua"
)

=== src/packet_io/CMakeLists.txt ===

set ( PACKET_IO_INCLUDES
    active.h
    active_action.h
    packet_constraints.h
    packet_tracer.h
    sfdaq.h
    sfdaq_instance.h
)

if (ENABLE_UNIT_TESTS)
    set(TEST_FILES
        test/sfdaq_module_test.cc
    )
endif (ENABLE_UNIT_TESTS)

if (ENABLE_STATIC_DAQ)
    foreach (STATIC_MODULE_NAME IN LISTS DAQ_STATIC_MODULES)
        string(APPEND DAQ_STATIC_MODULE_EXTERNS "extern const DAQ_ModuleAPI_t ${STATIC_MODULE_NAME}_daq_module_data;\n")
        string(APPEND DAQ_STATIC_MODULE_DATA_ARRAY "    &${STATIC_MODULE_NAME}_daq_module_data,\n")
    endforeach ()
    configure_file (
        "${CMAKE_CURRENT_SOURCE_DIR}/sfdaq_static_modules.h.in"
        "${CMAKE_CURRENT_BINARY_DIR}/sfdaq_static_modules.h"
    )
    set_source_files_properties(sfdaq.cc PROPERTIES COMPILE_DEFINITIONS ENABLE_STATIC_DAQ)
    include_directories(${CMAKE_CURRENT_BINARY_DIR})
    set(STATIC_DAQ_MODULES_HEADER "sfdaq_static_modules.h.in")
endif ()

add_library (packet_io OBJECT
    ${PACKET_IO_INCLUDES}
    active.cc
    active_counts.h
    packet_constraints.cc
    packet_tracer.cc
    packet_tracer_module.cc
    packet_tracer_module.h
    sfdaq.cc
    sfdaq_config.cc
    sfdaq_config.h
    sfdaq_instance.cc
    sfdaq_module.cc
    sfdaq_module.h
    trough.cc
    trough.h
    ${STATIC_DAQ_MODULES_HEADER}
    ${TEST_FILES}
)

add_subdirectory ( test )

install (FILES ${PACKET_IO_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/packet_io"
)

=== src/parser/CMakeLists.txt ===

add_library (parser OBJECT
    arg_list.cc
    arg_list.h
    parser.cc
    parser.h
    parse_conf.cc
    parse_conf.h
    parse_ip.cc
    parse_ip.h
    parse_ports.cc
    parse_ports.h
    parse_rule.cc
    parse_rule.h
    parse_so_rule.cc
    parse_so_rule.h
    parse_stream.cc
    parse_stream.h
    parse_utils.cc
    parse_utils.h
    cmd_line.cc
    cmd_line.h
    config_file.cc
    config_file.h
    var_dependency.cc
    var_dependency.h
    vars.cc
    vars.h
)

=== src/profiler/CMakeLists.txt ===
set ( PROFILER_INCLUDES
    memory_defs.h
    memory_profiler_defs.h
    profiler.h
    profiler_defs.h
    rule_profiler_defs.h
    time_profiler_defs.h
    )

set ( PROFILER_SOURCES
    active_context.h
    json_view.cc
    json_view.h
    memory_context.cc
    memory_context.h
    memory_profiler.cc
    memory_profiler.h
    profiler.cc
    profiler_impl.h
    profiler_module.cc
    profiler_module.h
    profiler_nodes.cc
    profiler_nodes.h
    profiler_printer.h
    profiler_stats_table.cc
    profiler_stats_table.h
    profiler_tree_builder.h
    rule_profiler.cc
    rule_profiler.h
    table_view.cc
    table_view.h
    time_profiler.cc
    time_profiler.h
    )

add_library ( profiler OBJECT
    ${PROFILER_SOURCES}
    ${PROFILER_INCLUDES}
)

install (FILES ${PROFILER_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/profiler"
)

add_catch_test( memory_context_test
    NO_TEST_SOURCE
    SOURCES
        memory_context.cc
)

add_catch_test( profiler_stats_table_test
    NO_TEST_SOURCE
    SOURCES
        profiler_stats_table.cc
)

=== src/pub_sub/CMakeLists.txt ===
set (PUB_SUB_INCLUDES
    appid_debug_log_event.h
    appid_event_ids.h
    appid_events.h
    assistant_gadget_event.h
    cip_events.h
    daq_message_event.h
    data_decrypt_event.h
    dcerpc_events.h
    detection_events.h
    dhcp_events.h
    dns_events.h
    domain_fronting.h
    eof_event.h
    eve_process_event.h
    expect_events.h
    external_event_ids.h
    file_events_ids.h
    file_events.h
    finalize_packet_event.h
    ftp_events.h
    http_body_event.h
    http_event_ids.h
    http_events.h
    http_publish_length_event.h
    http_request_body_event.h
    http_transaction_end_event.h
    intrinsic_event_ids.h
    netflow_event.h
    opportunistic_tls_event.h
    packet_events.h
    quic_events.h
    reputation_events.h
    rna_events.h
    shadowtraffic_aggregator.h
    sip_events.h
    smb_events.h
    ssh_events.h
    ssl_events.h
    stream_event_ids.h
    dns_payload_event.h
)

add_library( pub_sub OBJECT
    ${PUB_SUB_INCLUDES}
    cip_events.cc
    detection_events.cc
    dns_events.cc
    eof_event.cc
    http_body_event.cc
    http_events.cc
    http_request_body_event.cc
    http_transaction_end_event.cc
    quic_events.cc
    sip_events.cc
)

install (FILES ${PUB_SUB_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/pub_sub"
)

add_subdirectory ( test )

=== src/service_inspectors/CMakeLists.txt ===

add_subdirectory(back_orifice)
add_subdirectory(cip)
add_subdirectory(dce_rpc)
add_subdirectory(dnp3)
add_subdirectory(dns)
add_subdirectory(ftp_telnet)
add_subdirectory(gtp)
add_subdirectory(http_inspect)
add_subdirectory(http2_inspect)
add_subdirectory(iec104)
add_subdirectory(imap)
add_subdirectory(mms)
add_subdirectory(modbus)
add_subdirectory(netflow)
add_subdirectory(pop)
add_subdirectory(rpc_decode)
add_subdirectory(s7commplus)
add_subdirectory(sip)
add_subdirectory(smtp)
add_subdirectory(ssh)
add_subdirectory(ssl)
add_subdirectory(tlv_pdu)
add_subdirectory(wizard)

if (STATIC_INSPECTORS)
    set (STATIC_INSPECTOR_OBJS
        $<TARGET_OBJECTS:back_orifice>
        $<TARGET_OBJECTS:cip>
        $<TARGET_OBJECTS:dce_rpc>
        $<TARGET_OBJECTS:dnp3>
        $<TARGET_OBJECTS:ftp_telnet>
        $<TARGET_OBJECTS:gtp_inspect>
        $<TARGET_OBJECTS:iec104>
        $<TARGET_OBJECTS:imap>
        $<TARGET_OBJECTS:mms>
        $<TARGET_OBJECTS:modbus>
        $<TARGET_OBJECTS:netflow>
        $<TARGET_OBJECTS:pop>
        $<TARGET_OBJECTS:rpc_decode>
        $<TARGET_OBJECTS:s7commplus>
        $<TARGET_OBJECTS:smtp>
        $<TARGET_OBJECTS:ssh>
        $<TARGET_OBJECTS:ssl>
        $<TARGET_OBJECTS:tlv_pdu>
        $<TARGET_OBJECTS:wizard>
    )
endif()

set(STATIC_SERVICE_INSPECTOR_PLUGINS
    $<TARGET_OBJECTS:http_inspect>
    $<TARGET_OBJECTS:http2_inspect>
    $<TARGET_OBJECTS:sip>
    $<TARGET_OBJECTS:dns>
    ${STATIC_INSPECTOR_OBJS}
    CACHE INTERNAL "STATIC_SERVICE_INSPECTOR_PLUGINS"
)

add_library( service_inspectors OBJECT
    service_inspectors.cc
    service_inspectors.h
)

=== src/side_channel/CMakeLists.txt ===

add_library( side_channel OBJECT
    side_channel.cc
    side_channel.h
    side_channel_module.cc
    side_channel_module.h
    side_channel_format.cc
    side_channel_format.h
)

add_subdirectory(test)

=== debian/changelog ===
snort (3.9.7.0-0kali2) kali-dev; urgency=medium

  * Tighten libdaq3 dependency

 -- Arnaud Rebillout <arnaudr@kali.org>  Thu, 20 Nov 2025 09:57:15 +0700

snort (3.9.7.0-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * d/watch: Update to use github tags instead of snort download page.
  * d/upstream: Add upstream metadata

  [ Arnaud Rebillout ]
  * Drop mention of armel in debian/rules
  * New upstream version 3.9.7.0
  * Refesh DAQ patch
  * Build-depend on pcre2 instead of pcre3
  * Minor update of lintian overrides

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 19 Nov 2025 18:26:40 +0700

=== debian/control ===
Source: snort
Section: net
Priority: optional
XSBC-Original-Maintainer: Javier Fernández-Sanguino Peña <jfs@debian.org>
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Andrew Pollock <apollock@debian.org>
Build-Depends: 
    cmake,
    libnet1-dev, 
    libpcap0.8-dev, 
    libpcre2-dev, 
    debhelper-compat (= 13), 
    po-debconf (>= 0.5.0), 
    libdumbnet-dev, 
    libdaq3-dev (>= 3.0.22-0kali2),
    flex, 
    bison,
    pkgconf,
    zlib1g-dev,
    liblzma-dev,
    libluajit-5.1-dev,
    libnghttp2-dev,
    libfl-dev,
    libhwloc-dev,
    libssl-dev
Build-Depends-Indep: 
    texlive, 
    texlive-binaries, 
    texlive-latex-base, 
    texlive-font-utils,
    latex2html,
    ghostscript
Standards-Version: 4.6.2
Homepage: https://www.snort.org/
XS-Debian-Vcs-Git: https://salsa.debian.org/jfs/pkg-snort.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/jfs/pkg-snort
Vcs-Git: https://gitlab.com/kalilinux/packages/snort.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/snort

Package: snort
Architecture: any
Pre-Depends: adduser (>= 3.11), ${misc:Pre-Depends}
Depends: 
    snort-common-libraries (>=${binary:Version}),
    snort-rules-default (>= ${source:Version}), 
    snort-common (>= ${source:Version}),
    debconf (>= 0.2.80) | debconf-2.0,
    rsyslog | system-log-daemon,
    logrotate,
    net-tools,
    ${shlibs:Depends},
    ${misc:Depends}
Conflicts: 
    snort-mysql, 
    snort-pgsql
Replaces: snort-common (<< 2.0.2-3)
Recommends: iproute2
Suggests: snort-doc
Description: flexible Network Intrusion Detection System
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides the plain-vanilla version of Snort.

Package: snort-common
Architecture: all
Pre-Depends: adduser (>= 3.11), dpkg (>= 1.17.14), ${misc:Pre-Depends}
Depends: 
    perl, 
    debconf (>= 0.2.80) | debconf-2.0,
    ${shlibs:Depends},
    ${misc:Depends}
Conflicts: snort (<< ${binary:Version})
Replaces: snort (<< 1.8.4beta1-1)
Suggests: snort-doc
Description: flexible Network Intrusion Detection System - common files
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This is a common package which holds cron jobs, tools, and config files
 used by all the different package flavors.

Package: snort-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: doc
Description: flexible Network Intrusion Detection System - documentation
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides the documentation for Snort.

Package: snort-rules-default
Provides: snort-rules
Architecture: all
Depends: 
    debconf (>= 0.2.80) | debconf-2.0, 
    adduser (>= 3.11), 
    ${shlibs:Depends}, 
    ${misc:Depends}
Suggests: snort (>= 2.2.0) | snort-pgsql (>= 2.2.0) | snort-mysql (>= 2.2.0)
Recommends: oinkmaster
Homepage: http://www.snort.org/snort-rules/
Description: flexible Network Intrusion Detection System - ruleset
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This is the Snort default ruleset, which provides a basic set of network
 intrusion detection rules developed by the Snort community. They can be
 used as a basis for development of additional rules. Users using Snort to
 defend networks in production environments are encouraged to update their
 local rulesets as described in the included documentation or using the
 oinkmaster package.

Package: snort-common-libraries
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: snort (>= 2.7.0) | snort-pgsql (>= 2.7.0) | snort-mysql (>= 2.7.0)
Conflicts: snort-common (<< 2.7.0-6)
Description: flexible Network Intrusion Detection System - libraries
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides libraries used by all the Snort binary packages.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# Enable all hardening features as Snort is a network "listener" of sorts
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ 

override_dh_auto_test-indep:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%snort-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/snort3/snort3/tags .*/v?(\d\S*)\.tar\.gz debian
